#include<bits/stdc++.h>
#define FOR(i,s,e) for(int i=(s); i<=(e); i++)
#define FORD(i,s,e) for(int i=(s); i>=(e); i--)
#define ALL(k) (k).begin(),(k).end()
#define e1 first
#define e2 second
#define pb push_back


using namespace std;
using LL = long long;

const int MAXN = 200111;
const int POW = (1<<18);
const bool debug=false;
const LL MOD = (LL)1e9 + 7;


int n;
LL a0[MAXN];
LL tree_gcd[3*POW];

LL gcd_wrap(LL aa, LL bb){
	return (aa == 0 || bb == 0) ? 0 : __gcd(aa,bb);
}
void prep_tree_gcd(){
	FOR(i,1,n) tree_gcd[i+POW-1] = a0[i];
	FORD(i,POW-1,1){
		tree_gcd[i] = gcd_wrap(tree_gcd[2*i], tree_gcd[2*i+1]);
		//if(tree_gcd[i] != 0) printf("TGCD %16d %d\n", i, tree_gcd[i]);
	}
}

int find_new_gcd(int pos, LL gc){
	int v = pos + POW - 1;
	while(v>1 && (v%2 == 1 || gcd_wrap(gc, tree_gcd[v+1]) == gc)){
		v /= 2;
	}
	v++;
	//printf("Now at %d\n", v);
	while (v < POW){
		if(gcd_wrap(gc, tree_gcd[2*v]) == gc){
			//printf("R %d\n",v);
			v = v*2 + 1;
		}
		else {
			//printf("L %d\n",v);
			v = 2*v;
		}
	}
	return v - POW + 1;
}


LL maxchg[3*POW];
LL maxsums[3*POW];
int st,en; LL val;

void upd(int a, int b, int v){
	maxsums[v] += maxchg[v] * (LL)(b-a+1);
	if (v < POW){
		maxchg[2*v] += maxchg[v];
		maxchg[2*v+1] += maxchg[v];
	}
	maxchg[v] = 0;
}

void trmax_update(int a, int b, int v){
	upd(a,b,v);
	if(st <= a && b <= en){
		maxchg[v] += val;
		upd(a,b,v);
		return;
	}
	int mid = (a+b) / 2;
	if (st <= mid){
		trmax_update(a,mid, 2*v);
	}
	if(mid < en){
		trmax_update(mid+1, b, 2*v+1);
	}
	upd(a,mid,2*v);
	upd(mid+1,b,2*v+1);
	maxsums[v] = maxsums[2*v]+maxsums[2*v+1];
}

LL trmax_query(int a, int b, int v){
	upd(a,b,v);
	if(st <= a && b <= en){
		return maxsums[v];
	}
	LL ans = 0;
	int mid = (a+b)/2;
	if (st <= mid){
		ans = trmax_query(a,mid,2*v);
	}
	if (mid < en){
		ans += trmax_query(mid+1, b, 2*v+1);
	}
	upd(a,mid,2*v);
	upd(mid+1,b,2*v+1);
	maxsums[v] = maxsums[2*v]+maxsums[2*v+1];
	return ans;
}

LL sum_maxes(int a, int b){
	st = a, en = b;
	LL ans = trmax_query(1, POW, 1);
	if(debug)printf("\t\tFrom %d to %d counted %lld\n", st,en,ans);
	return ans % MOD;
}

int next_max_pos[MAXN];

void update_maxes(int pos){
	
	// eliminate old max
	st = pos-1, en = next_max_pos[pos-1]-1;
	val = -a0[pos-1];
	if(debug)printf("On interval %d %d remove %lld\n", st, en, -val);
	trmax_update(1,POW,1);
	
	int limit = en+1;
	
	while (pos < limit){
		int next_pos = next_max_pos[pos];
		st = pos, en = next_pos - 1;
		val = a0[pos];
		if(debug)printf("On interval %d %d add %lld\n", st, en, val);
		trmax_update(1,POW,1);
		
		pos = next_pos;
	}
}

void prep_next_max(){
	vector<int> curmaxes;
	FOR(i,1,n){
		while(!curmaxes.empty() && a0[curmaxes.back()] < a0[i]){
			next_max_pos[curmaxes.back()] = i;
			curmaxes.pop_back();
		}
		curmaxes.pb(i);
	}
	while(!curmaxes.empty()){
		next_max_pos[curmaxes.back()] = n+1;
		curmaxes.pop_back();
	}
}
	




main(){
	scanf("%d",&n);
	FOR(i,1,n) scanf("%lld", &a0[i]);
	next_max_pos[0] = n+1;
	
	prep_next_max();
	prep_tree_gcd();
	LL ans = 0;
	FOR(i,1,n){
		LL cur_gcd = a0[i];
		int pos = i;
		update_maxes(i);
		if(debug)printf("Position %d value %lld::\n", i, cur_gcd);
		while(pos <= n){
			int new_pos = find_new_gcd(pos, cur_gcd);
			if(new_pos > n) new_pos = n+1;
			LL new_gc = gcd_wrap(cur_gcd, a0[new_pos]);
			if(debug)printf("\tPos %d -> %d: vals %lld -> %lld\n", pos, new_pos, cur_gcd, new_gc);
			LL smax =  sum_maxes(pos, new_pos - 1);
			if(debug)printf("\tSum of maxes %lld\n", smax);
			LL ans_add = ((LL)cur_gcd * smax)%MOD;
			ans += ans_add;
			ans %= MOD;
			if(debug)printf("\tAdding %lld\n", ans_add);
			cur_gcd = new_gc;
			pos = new_pos;
		}
	}
	printf("%lld\n", ans);
}

/*
4
1 2 3 4
On interval 0 5 remove 0
On interval 1 1 add 1
On interval 2 2 add 2
On interval 3 3 add 3
On interval 4 4 add 4
Position 1 value 1::
	Pos 1 -> 5: vals 1 -> 0
		From 1 to 4 counted 0
	Sum of maxes 0
	Adding 0
On interval 1 2 remove 1
Position 2 value 2::
	Pos 2 -> 3: vals 2 -> 1
		From 2 to 2 counted 0
	Sum of maxes 0
	Adding 0
	Pos 3 -> 5: vals 1 -> 0
		From 3 to 4 counted 0
	Sum of maxes 0
	Adding 0
On interval 2 3 remove 2
Position 3 value 3::
	Pos 3 -> 4: vals 3 -> 1
		From 3 to 3 counted 0
	Sum of maxes 0
	Adding 0
	Pos 4 -> 5: vals 1 -> 0
		From 4 to 4 counted 0
	Sum of maxes 0
	Adding 0
On interval 3 4 remove 3
Position 4 value 4::
	Pos 4 -> 5: vals 4 -> 0
		From 4 to 4 counted 0
	Sum of maxes 0
	Adding 0
0
*/
